#include <cstdio>
#include <vector>
#include <algorithm>
#include <queue>

using namespace std;

const int MAXINT = 2000000000;

struct S {
	int to,d,t,a,l;
	S(int nto,int nd,int nt,int na,int nl) : to(nto),d(nd),t(nt),a(na),l(nl) {}
};

struct P {
	int i,w;
	P(int ni, int nw) : i(ni),w(nw) {}
	bool operator<(const P &s) const {
		return w>s.w;
	}
};

unsigned czekanie(int x, const S &s) {
	if (s.t==0 && s.a==0 && s.l==0)
		return 0;
	int xamod = (s.t + x - s.a) % s.t;
	if (xamod < s.l)
		return 0;
	return s.t - xamod;
}

int main() {
	int tc;
	scanf("%d",&tc);
	while (tc--) {
		int n,m;
		//wczytywanie
		scanf("%d %d", &n, &m);
		vector<S> t[n+1];
		while (m--) {
			int v,w,d,tt,a,l;
			scanf("%d %d %d %d %d %d", &v, &w, &d, &tt, &a, &l);
			if (v!=w) {
				S tmpS(w,d,tt,a,l);
				t[v].push_back(tmpS);
			}
		}
		//dijkstra
		bool bylo[n+1];
		int w[n+1];
		for (int i=1; i<=n; i++) {
			bylo[i] = false;
			w[i]=MAXINT;
		}
		priority_queue<P, vector<P> > kol;
		kol.push(P(1,0));
		w[1]=0;
		
		bool puste=false;
		bool done=false;
		do {
			if (kol.empty()) {
				puste=true;
			} else {
				P v_P = kol.top();
				kol.pop();
				int v = v_P.i;
				if (!bylo[v]) {
					int aw = v_P.w;
//					printf("v=%d w[v]=%d\n", v, w[v]);
					if (v==n) {
						done=true;
					} else {
						bylo[v] = true;
						for (unsigned i=0; i<t[v].size(); ++i) {
							S &aktK = t[v][i];
							if (!bylo[ aktK.to ]) {
//								printf("*\n");
								int nowe = aw + czekanie(aw,aktK) + aktK.d;
								if (w[aktK.to] > nowe)
									w[aktK.to] = nowe;
								kol.push(P(aktK.to,w[aktK.to]));
							}
						}
					}

				}
				
			}
		} while (!puste && !done);
		if (w[n]==MAXINT) {
			printf("NIE\n");
		} else {
			printf("%d\n", w[n]);
		}

	}
}
